/** CONFIG AREA **/
var PERFORMANCE_LEVEL_LOW = 0;
var PERFORMANCE_LEVEL_HIGH =1;
var FOCUS_PERFORMANCE_LEVEL = PERFORMANCE_LEVEL_HIGH;

var FOCUS_MOVE_NONEBLOCKING = 0;
var FOCUS_MOVE_BLOCKING = 1;
var FOCUS_ISBLOCKING = FOCUS_MOVE_BLOCKING;

var TAG_A = 'a';
var TAG_SPAN = 'span';
var TAG_STOREHREF_4CFAKEFOCUS =TAG_A;

/** CONST AREA **/
var MOVE_TYPE_SUBINDEX_MOVE = 0;// subindex change
var MOVE_TYPE_SECTION_MOVE = 1;// section change 
var MOVE_TYPE_PAGE_SWITCH_UP = 2;// page change 
var MOVE_TYPE_PAGE_SWITCH_DOWN = 3;// page change
var MOVE_TYPE_NONE = 4;//do nothing 

var MOVE_LEFT = 0;
var MOVE_RIGHT = 1;
var MOVE_UP = 2;
var MOVE_DOWN = 3;

var FOCUS_RESTORE = {};

// should make sure keycode is up down left right
function onFocusPressMove(keycode,move_map,focus) {
	if(!static_focus_enable) {
		vlog('==weblog==',"Focus Disabling");
		return focus;
	}

	if (static_CFakeFocus_isMoving && FOCUS_ISBLOCKING == FOCUS_MOVE_BLOCKING) {
		vlog('==weblog==',"Focus is Moving ,press too fast");
		return focus;
	}

	if (static_Pager_isSwitching) {
		vlog('==weblog==',"Page is Switching,press too fast");
		return focus;
	}

	var target = focus;
	if (!target)
		return focus;
	var sectionIndex;
	var subIndex;
	var move_event = GetMoveEvent(target,keycode)

	var isPageAnimation = false;

	if(!move_event)
		return focus;

	if (move_event.mType == MOVE_TYPE_SUBINDEX_MOVE || move_event.mType == MOVE_TYPE_SECTION_MOVE ){
		sectionIndex = move_event.mTarSec;
		subIndex = move_event.mTarSub;
	} else if ( move_event.mType == MOVE_TYPE_PAGE_SWITCH_UP || move_event.mType == MOVE_TYPE_PAGE_SWITCH_DOWN ) {
		isPageAnimation = true;
		sectionIndex = move_event.mTarSec;
		subIndex = move_event.mTarSub;
	} else {
		return focus;
	}

	if(isPageAnimation) {
		var preRes = false;
		if( move_event.mType == MOVE_TYPE_PAGE_SWITCH_UP ) {
			preRes = move_map[sectionIndex].prePageUp();
		} else if( move_event.mType == MOVE_TYPE_PAGE_SWITCH_DOWN ) {
			preRes = move_map[sectionIndex].prePageDown();
		}

		if(!preRes) {
			return focus;
		}
	}

	var new_target = move_map[sectionIndex].getFocus(subIndex);
	if(!new_target.Enable()) {
		move_map[sectionIndex].cancelPageAction();
		return focus;
	}

	target.RemoveFocus();

	var options = {};
	options.remove = target.getMoveOutOptions();

	// when page switch item locate may change , so modify options in pageUp| pageDown function
	if(isPageAnimation) {
		if( move_event.mType == MOVE_TYPE_PAGE_SWITCH_UP ) {
			options = move_map[sectionIndex].pageUp(options);
		} else if( move_event.mType == MOVE_TYPE_PAGE_SWITCH_DOWN ) {
			options = move_map[sectionIndex].pageDown(options);
		}
	}

	if(!new_target) {
		return focus;
	}

	focus = new_target;
	focus.AppendFocus(options); 
	return focus;
}

//for suck feature
function extCallPageSwitch(move_map,focus,movetype,sectionid) {
	if(!static_focus_enable) {
		vlog('==weblog==',"Focus Disabling");
		return focus;
	}

	if (static_CFakeFocus_isMoving && FOCUS_ISBLOCKING == FOCUS_MOVE_BLOCKING) {
		vlog('==weblog==',"Focus is Moving ,press too fast");
		return focus;
	}

	if (static_Pager_isSwitching) {
		vlog('==weblog==',"Page is Switching,press too fast");
		return focus;
	}

	var target = focus;
	if (!target)
		return ;

	target.RemoveFocus();

	var options = {}
	options.remove = target.getMoveOutOptions();

	if(movetype == MOVE_TYPE_PAGE_SWITCH_UP) {
		options = move_map[sectionid].pageUp(options);
	} else if(movetype ==  MOVE_TYPE_PAGE_SWITCH_DOWN) {
		options = move_map[sectionid].pageDown(options);
	}

	if(options == false) {
		options = {};
		options.remove = target.getMoveOutOptions();
		target.AppendFocus(options);
		return focus;
	}

	//for suck feature auto first 
	var new_target = move_map[sectionid].getFocus(0);

	if(!new_target) {
		return focus;
	}

	focus = new_target;
	focus.AppendFocus(options); 
	return focus;
}

function onFocusClick(keycode,move_map,focus) {
	if(!static_focus_enable) {
		vlog('==weblog==',"Focus Disabling");
		return false;
	}

	if (static_CFakeFocus_isMoving) {
		vlog('==weblog==',"Focus is Moving ,press too fast");
		return false;
	}

	if (static_Pager_isSwitching) {
		vlog('==weblog==',"Page is Switching,press too fast");
		return false;
	}
	
	var target = focus;
	if(!target || typeof target != 'object' || !(target instanceof CFakeFocus))
		return false;


	target.onClick();

	return true;
}

//for default focus,maybe shouldn't put here
function default_focus(hover_frame_jqobj,JQ_obj,type,buttontype,option,callback){
	var speed = 300;// move speed

	var pos_x = JQ_obj.offset().left;
	var pos_y = JQ_obj.offset().top;
	var width = parseInt(JQ_obj.width());
	var height = parseInt(JQ_obj.height());
	
	//fix the obj with border may cause display error
	var border = parseInt(JQ_obj.css('border-width')) ? parseInt(JQ_obj.css('border-width')):0 ;
	width = border*2 + width;
	height = border*2 + height;
	
	if(!hover_frame_jqobj && hover_frame_jqobj.length == 0 )
		return ;

	if(!option) {
		option ={};
	} 

	if(FOCUS_ISBLOCKING == FOCUS_MOVE_NONEBLOCKING && FOCUS_RESTORE.remove_option) {
		if(FOCUS_RESTORE.lastframe != hover_frame_jqobj) {
			option.remove = $.extend(true,{},FOCUS_RESTORE.remove_option);
			delete(FOCUS_RESTORE.remove_option);
		}
	}
	if (option.pageswitch) {
		if(option.pageswitch.left_offset) {
			pos_x = pos_x + option.pageswitch.left_offset;
		}
		if(option.pageswitch.top_offset) {
			pos_y = pos_y + option.pageswitch.top_offset;
		}
	}

	vlog('==weblog==','Move In Options  '+" left:"+pos_x+" top:"+pos_y+" width:"+width+" height:"+height);
	option.append = {"left":pos_x,"top":pos_y,"width":width,"height":height};

	if( type == FOCUS_TYPE_APPEND) {
		if(FOCUS_RESTORE.hoverframe) {
			for(var i in FOCUS_RESTORE.hoverframe) {
				if(FOCUS_RESTORE.hoverframe[i] != hover_frame_jqobj) {
					FOCUS_RESTORE.hoverframe[i].stop();
					FOCUS_RESTORE.hoverframe[i].css({display:'none'});
				}
			}
		}
		if(FOCUS_RESTORE.lastframe != hover_frame_jqobj) {
			if(FOCUS_RESTORE.lastframe) {
				FOCUS_RESTORE.lastframe.hide();
			}
		}
		if(FOCUS_PERFORMANCE_LEVEL == PERFORMANCE_LEVEL_HIGH) {
			if(FOCUS_RESTORE.lastframe == hover_frame_jqobj) {
				hover_frame_jqobj.show().animate(option.append,speed,callback);
			} else {
				hover_frame_jqobj.css(option.remove).show().animate(option.append,speed,callback);
			}
		} else {
			hover_frame_jqobj.css(option.append).show();
			callback();
		}
	} else if ( type == FOCUS_TYPE_REMOVE) {
		FOCUS_RESTORE.lastframe = hover_frame_jqobj;
		hover_frame_jqobj.stop(true);
	/**	
		FOCUS_RESTORE["remove_option"] = {left:hover_frame_jqobj.offset().left,
				top:hover_frame_jqobj.offset().top,
				width:hover_frame_jqobj.width(),
				height:hover_frame_jqobj.height()
				};

		hover_frame_jqobj.css({display:'none'});**/
	}
}

//for default page up and page down need jquery scroll support
function default_pageswitch(option,jq_tag,switch_type,scroll_type,callback) {
	if( !option || !option.step_width) {
		return option;
	}
	if(switch_type == SECTION_PAGE_DOWN) {
		if(scroll_type == SCROLLTYPE_HORIZONTAL) {
			if(FOCUS_PERFORMANCE_LEVEL == PERFORMANCE_LEVEL_HIGH) {
				$.ScrollLeft({
					stepWidth:option.step_width,
					obj:jq_tag,
					callback:callback
				});
				//because of animate delay,so need recalculate the focus position
				if(option.pageswitch){}
				else {
					option.pageswitch = {};
				}
				var zoom = $('body').css('zoom');
				option.pageswitch.left_offset = (0-option.step_width)*zoom;
			} else {
				$(jq_tag).css({left:parseInt($(jq_tag).css('left'))-option.step_width});
				callback();
			}
		} else if (scroll_type == SCROLLTYPE_VERTICAL) {
			if(FOCUS_PERFORMANCE_LEVEL == PERFORMANCE_LEVEL_HIGH) {
				$.ScrollUp({
					stepWidth:option.step_width,
					obj:jq_tag,
					callback:callback
				});
				if(option) {
					if(option.pageswitch){}
					else {
						option.pageswitch = {};
					}
					var zoom = $('body').css('zoom');
					option.pageswitch.top_offset = (0-option.step_width)*zoom;
				}
			} else {
				$(jq_tag).css({top:parseInt($(jq_tag).css('top'))-option.step_width});
				callback();
			}
		}
		
	} else if(switch_type == SECTION_PAGE_UP) {
		if(scroll_type == SCROLLTYPE_HORIZONTAL) {
			if(FOCUS_PERFORMANCE_LEVEL ==  PERFORMANCE_LEVEL_HIGH) {
				$.ScrollRight({
					stepWidth:option.step_width,
					obj:jq_tag,
					callback:callback
				});

				//because of animate delay,so need recalculate the focus position
				if(option.pageswitch){}
				else {
					option.pageswitch = {};
				}
				var zoom = $('body').css('zoom');
				option.pageswitch.left_offset = option.step_width*zoom;
			} else {
				$(jq_tag).css({left:parseInt($(jq_tag).css('left'))+option.step_width});
				callback();
			}
		} else if (scroll_type == SCROLLTYPE_VERTICAL) {
			if(FOCUS_PERFORMANCE_LEVEL == PERFORMANCE_LEVEL_HIGH) {
				$.ScrollDown({
					stepWidth:option.step_width,
					obj:jq_tag,
					callback:callback
				});
				if(option) {
					if(option.pageswitch){}
					else {
						option.pageswitch = {};
					}
					var zoom = $('body').css('zoom');
					option.pageswitch.top_offset = option.step_width*zoom;
				}
			} else {
				$(jq_tag).css({top:parseInt($(jq_tag).css('top'))+option.step_width});
				callback();
			}
		}
	}
	return option;
}

//for Sync Button State Display change
function default_sync_button_block(hover_frame_jqobj,JQ_obj,state,display_tag){
	if(!display_tag) {
		display_tag = 'img';
	}

	var sync_y_offset = 3;
	var sync_x_offset = 3;

	if(!state) {
		sync_y_offset = 0-sync_y_offset;
		sync_x_offset = 0-sync_x_offset;
	}

	var display_obj = JQ_obj.children('a').children('img');
	if(!display_obj || !display_obj.length) {
		return ;
	}

	var origin_x = parseInt(display_obj.css('margin-left')) ? parseInt(display_obj.css('margin-left')):0;
	var origin_y = parseInt(display_obj.css('margin-top')) ? parseInt(display_obj.css('margin-left')):0;

	var after_x = origin_x + sync_y_offset;
	var after_y = origin_y + sync_y_offset;

	display_obj.css('margin-left',after_x);
	display_obj.css('margin-top',after_y);
}

var KEYCODEMOVE_MAP = [];
KEYCODEMOVE_MAP[MOVE_LEFT] = KEY_LEFT;
KEYCODEMOVE_MAP[MOVE_RIGHT] = KEY_RIGHT;
KEYCODEMOVE_MAP[MOVE_UP] = KEY_UP;
KEYCODEMOVE_MAP[MOVE_DOWN] = KEY_DOWN;

function GetMoveEvent(target,keycode){
	for(move in KEYCODEMOVE_MAP) {
		if(KEYCODEMOVE_MAP[move] == keycode) {
			return target.mMoveEvent[move];
		}
	}
}

function CMoveEvent() {
	this.mType = MOVE_TYPE_NONE;
	
	this.mTarSec;
	this.mTarSub;

	this.MoveFunc = function(){};

	this.SetOptions = function (type,sec,sub,func) {
		this.mType = type;
		this.mTarSec = sec;
		this.mTarSub = sub;
		if(typeof func == 'function'){
			this.MoveFunc = func;
			vlog('==weblog==','CMoveEvent set func');
		}
	}
}

// for mFunctionalType
var BUTTON_TYPE_NONE = 0;
var BUTTON_TYPE_SELECTED = 1;

//flag for foucs moving
var static_CFakeFocus_isMoving = false;
//flag for page switching
var static_Pager_isSwitching = false;

var FOCUS_TYPE_APPEND = 0;
var FOCUS_TYPE_REMOVE = 1;
function CFakeFocus(){
	//flag for FakeFocus is Sync or Async
	this.mbSync = false;
	//Sync State true for blocking false for not blocking
	this.mSyncState = false;
	//Sync State Display change
	this.SyncStateCallBack = function(jqobj,state){}

	this.SetFocusSyncFunc = function(func) {
		if(typeof func != 'function') {
			return false;
		} else {
			this.SyncStateCallBack = func;
			return true;
		}
	}

	this.mFunctionalType = BUTTON_TYPE_NONE;
	this.SetFunctionalType = function(type) {
		mFunctionalType = type;
		return true;
	}
	this.mMoveEvent = new Array(4);

	this.SetMoveEvent = function(moveType,moveEvent) {
		if(moveType >=0 && moveType <=4 && moveEvent instanceof CMoveEvent ) {
			mMoveEvent[moveType] = moveEvent;
			return true;
		} else
			return false;
	}

	this.SetMoveEventArray = function(moveEventArray) {
		this.mMoveEvent = moveEventArray;
	}

	this.mJqueryObj;
	this.SetJqueryObj = function(obj) {
		if(obj instanceof jQuery && obj.length>0) {
			this.mJqueryObj = obj;

			//defalut
			this.mMoveOutOptions = {"left":this.mJqueryObj.offset().left,
									"top":this.mJqueryObj.offset().top,
									"width":this.mJqueryObj.width(),
									"height":this.mJqueryObj.height()
									};
			return true;
		} else
			return false;
	}

	this.Enable = function() {
		if(this.mJqueryObj) {
			if(!this.mJqueryObj.is(":hidden") ) {
				return true;
			}
		}

		return false ;
	}

	this.FocusFunc = function(){
		vlog('==weblog==','Did not define FocusFunc');
	};
	this.SetFocusFunc = function(focusFunc) {
		if(typeof focusFunc == 'function') {
			this.FocusFunc = focusFunc;
			return true;
		} else
			return false;
	}

	this.endFocusCallBack = function() {
		vlog('==weblog==','Moving Call Back is Called');
		static_CFakeFocus_isMoving = false;
	}

	this.AppendFocus = function(option) {
		this.FocusFunc(this.mJqueryObj,
					FOCUS_TYPE_APPEND,
					this.mFunctionalType,
					option,
					this.endFocusCallBack);
		return this;
	}

	//for init focus
	this.FirstAppendFocus = function(){
		var out_opt = {};
		out_opt.remove = this.getMoveOutOptions();
		return this.AppendFocus(out_opt);
	}

	this.RemoveFocus = function(option) {
		if(!static_CFakeFocus_isMoving) {
			static_CFakeFocus_isMoving = true;
			this.FocusFunc(this.mJqueryObj,
					FOCUS_TYPE_REMOVE,
					this.mFunctionalType,
					option,
					this.endFocusCallBack);
		}
	}


	this.mMoveOutOptions ={};
	this.getMoveOutOptions = function () {
		this.mMoveOutOptions = {"left":this.mJqueryObj.offset().left,
								"top":this.mJqueryObj.offset().top,
								"width":this.mJqueryObj.width(),
								"height":this.mJqueryObj.height()
								};
		return this.mMoveOutOptions;
	}

	this.setMoveOutOptions = function (option) {
		this.mMoveOutOptions = options;
	}

	this.onClick =function(option){
		if(this.mbSync && this.mSyncState) {
			return ;
		}

		if(this.mbSync) {
			vlog('==weblog==','button sync state be set to true');
			this.mSyncState = true;
			this.SyncStateCallBack(this.mJqueryObj,this.mSyncState);
		}
		//check if children a tag if exist;
		var result;
		var jq_child = this.mJqueryObj.children(TAG_STOREHREF_4CFAKEFOCUS);
		if (jq_child.length > 0 && jq_child.attr('href')){
			var script = jq_child.attr('href');
			result = eval(script);
		}

		if(this.mbSync) {
			vlog('==weblog==','button sync state be set to false');
			this.mSyncState = false;
			this.SyncStateCallBack(this.mSyncState);
		}
		return result;
	}
}

var SECTION_PAGE_DOWN = 1;
var SECTION_PAGE_UP = 0;

function CSection() {
	this.mIsPage = false;

	this.mItemPerPage = 0;

	this.mFakeFocus = [];

	this.mCurrentPage = 0;
	this.mMaxPageIndex = 0;

	this.mLastPageIndex = null;

	this.pageSwitchCallBack = function() {
		static_Pager_isSwitching = false;
	}

	this.getFocus = function(sub_index) {
		if(this.mIsPage && sub_index>=this.mItemPerPage) {
			vlog('==weblog==','page map error,out of page range');
			return false;
		}

		if(!this.mIsPage && sub_index>=this.mFakeFocus.length ) {
			vlog('==weblog==','page map error,out of section range');
			return false;
		}


		if(this.mIsPage) {
			if(this.mCurrentPage*this.mItemPerPage+sub_index>=this.mFakeFocus.length) {
				vlog('==weblog==','out fo section range');
				return false;
			} else {
				return this.mFakeFocus[this.mCurrentPage*this.mItemPerPage+sub_index];
			}
		} else {
			return this.mFakeFocus[sub_index];
		}
	}

	//need override
	this.mPageSwitch = function(option,switch_type,callback) {}

	this.setPageSwitchFunc = function (func) {
		if(typeof func != 'function')
			return false;
		this.mPageSwitch = func;
	}

	this.pageDown = function(option) {
		static_Pager_isSwitching = true;
		if(option == undefined) {
			option = {};
		}

		option.current_page = this.mCurrentPage;
		this.mLastPageIndex = null;
		return this.mPageSwitch(option,SECTION_PAGE_DOWN,this.pageSwitchCallBack);
	}

	this.pageUp = function(option) {
		static_Pager_isSwitching = true;
		if(!option) {
			option = {};
		}

		option.current_page = this.mCurrentPage;
		this.mLastPageIndex = null;
		return this.mPageSwitch(option,SECTION_PAGE_UP,this.pageSwitchCallBack);
	}

	this.prePageDown = function() {
		if(this.mCurrentPage == this.mMaxPageIndex) {
			vlog("==weblog==","pager could not page down");
			return false;
		}
		this.mLastPageIndex = this.mCurrentPage;
		this.mCurrentPage = this.mCurrentPage+1;

		return true;
	}

	this.prePageUp = function() {
		if(this.mCurrentPage == 0) {
			vlog("==weblog==","pager could not page down");
			return false;
		}
		this.mLastPageIndex = this.mCurrentPage;
		this.mCurrentPage = this.mCurrentPage-1;

		return true;
	}

	this.cancelPageAction = function() {
		if(this.mLastPageIndex != null) {
			this.mCurrentPage = this.mLastPageIndex;
		}
	}
}

//return focus func
function getFocusMethod(tag){
	try {
		var result = eval(tag+'_focus');
	} catch (e) {
		vlog("==weblog==",e.message);
	}
	return result;
}

// return section page func
function getSectionPageSwitchMethod(tag) {
	try {
		var result = eval(tag+'_focus');
	} catch (e) {
		vlog("==weblog==",e.message);
	}
	return eval(tag+'_pageswitch');
}

// return sync func
function getSyncMethod(tag) {
	try {
		var result = eval(tag+'_sync');
	} catch (e) {
		vlog('==weblog==',e.message);
	}

	return result;
}

//init global.moveMap
function init_moveMap(move_map,map_json) {
	$(map_json).each(function(){
		var section_id = this.id;
		move_map[section_id] = new CSection();

		if(this.is_page && this.item_perpage) {
			move_map[section_id].mIsPage = this.is_page;
			move_map[section_id].mItemPerPage = this.item_perpage;
			move_map[section_id].setPageSwitchFunc(getSectionPageSwitchMethod(this.tag));
			move_map[section_id].mMaxPageIndex = this.maxpage-1;
		}

		var sub = this.sub;
		$(sub).each(function(){
			var sub_id = this.id;
			var focus_obj = new CFakeFocus();

			// bind element
			var tag_prefix = '';
			var class_or_id = 0;// 0 stand for class ,1 stand for id
			if(this.tagtype == 'class'){
				tag_prefix = '.';
				class_or_id = 0;
			}
			else if ( this.tagtype == 'id' ) {
				tag_prefix = '#';
				class_or_id = 1;
			}

			var jq_obj;
			if(class_or_id == 0)
				jq_obj = $($(tag_prefix+this.tag).toArray()[sub_id]);
			else if( class_or_id == 1)
				jq_obj = $(tag_prefix+this.tag);

			if(!focus_obj.SetJqueryObj(jq_obj)){
				vlog('==weblog==','null jq obj, map not match with html');
				return ;
			}

			//bind function
			focus_obj.SetFocusFunc(getFocusMethod(this.tag));
			var left_event = new CMoveEvent();
			var right_event = new CMoveEvent();
			var up_event = new CMoveEvent();
			var down_event = new CMoveEvent();

			var events = this.events;
			if (events.left != "")
				left_event.SetOptions(events.left.type,events.left.sec,events.left.sub);
			if (events.right != "")
				right_event.SetOptions(events.right.type,events.right.sec,events.right.sub);
			if (events.up != "")
				up_event.SetOptions(events.up.type,events.up.sec,events.up.sub);
			if (events.down != "")
				down_event.SetOptions(events.down.type,events.down.sec,events.down.sub);

			var event_arr = [];
			event_arr[MOVE_LEFT] = left_event;
			event_arr[MOVE_RIGHT] = right_event;
			event_arr[MOVE_UP] = up_event;
			event_arr[MOVE_DOWN] = down_event;
			focus_obj.SetMoveEventArray(event_arr);

			//set focus async or sync
			//only for focus click event
			if(parseInt(this.sync)) {
				vlog('==weblog==','set '+this.tag+' sync');
				focus_obj.mbSync = true;
				focus_obj.mJqueryObj.click({_focus:focus_obj},syncwrap_focus);
				focus_obj.SetFocusSyncFunc = getSyncMethod(this.tag);
			}

			move_map[section_id].mFakeFocus[sub_id] = focus_obj;
		});
	});
}


//Gernerate gamelist event map
//option format:
//option.row.count = 3
//option.row.top = {type:all,sec:2,sub:0} (tips:if not all to be implement)
//option.col.count = 5
//option.col.leftedge = {type:all,sec:0,sub:0} (tips:if not all to be implement)
//option.secindex = 1(tips: Gamelist'Section in page map array index)
//option.tag = 'game_collector' 
//option.subtag = 'game_picker'

var SCROLLTYPE_VERTICAL = 0;
var SCROLLTYPE_HORIZONTAL = 1;
function gernerateGameListEventMap(list_json,option) {
	if(option.scrolltype == undefined)
		option.scrolltype = SCROLLTYPE_HORIZONTAL;

	if(option.row == undefined || option.row.count == undefined 
	|| option.col == undefined || option.col.count == undefined
	|| option.secindex == undefined || option.tag == undefined || option.subtag == undefined) {
		vlog('==weblog==','Generate Move Fail:option invalid');
		return false;
	}
	
	var item_id = 0;
	var item_row = option.row.count;
	var item_col = option.col.count;
	var item_perpage = option.row.count * option.col.count;
	var item_maxid = list_json.length-1;
	var item_maxrow = Math.ceil(list_json.length/item_col);
	var item_maxpage = Math.ceil(list_json.length/item_perpage);

	var result = {};
	result.id = option.secindex;
	result.tag = option.tag;
	result.sub = [];
	result.maxpage = item_maxpage;
	if(item_maxpage <=1){
		result.is_page=false;
	} else {
		result.is_page = true;
		result.item_perpage = item_perpage;
	}

	$(list_json).each(function(){
		var item = {};
		item.id = item_id;
		item.tag = option.subtag;
		item.tagtype = 'class';
		var events = {};

		//left event
		if(item_id%item_col == 0) {// left col of page
			if(item_id<item_perpage || option.scrolltype == SCROLLTYPE_VERTICAL) {
				if(!option.col.leftedge)
					events.left = "";
				else
					events.left = {"type":MOVE_TYPE_SECTION_MOVE,"sec":option.col.leftedge.sec,"sub":option.col.leftedge.sub};
			} else {
				// page switch to the same row but the right edge element
				events.left = {"type":MOVE_TYPE_PAGE_SWITCH_UP,"sec":option.secindex,"sub":item_id%item_perpage+item_col-1};
			}
			
		} else {
			events.left = {"type":MOVE_TYPE_SUBINDEX_MOVE,"sec":option.secindex,"sub":item_id%item_perpage-1};
		}

		//right event
		if(item_id%item_col ==  item_col-1){// right col of page
			if(option.scrolltype == SCROLLTYPE_VERTICAL) {
				events.right = "";
			} else {
				var current_page_index = Math.floor(item_id/item_perpage);
				
				if(current_page_index == item_maxpage -1) {
					events.right = "";
				} else if(current_page_index == item_maxpage -2 ) {// last page before should consider the last page not full
					var tar_item = item_id + item_perpage - item_col +1;
					while(tar_item>=list_json.length) {
						tar_item = tar_item - item_col;
					}
					events.right = {"type":MOVE_TYPE_PAGE_SWITCH_DOWN,"sec":option.secindex,"sub":tar_item%item_perpage};
				} else {
					events.right = {"type":MOVE_TYPE_PAGE_SWITCH_DOWN,"sec":option.secindex,"sub":item_id%item_perpage-item_col+1};
				}
			}
		} else {
			if(item_id == list_json.length-1)
				events.right="";
			else
				events.right = {"type":MOVE_TYPE_SUBINDEX_MOVE,"sec":option.secindex,"sub":item_id%item_perpage+1}
		}

		//up evnet
		if(item_id%item_perpage<item_col) {
			if(item_id<item_perpage || option.scrolltype == SCROLLTYPE_HORIZONTAL)
				if(!option.row.top) 
					events.up = "";
				else 
					events.up = {"type":MOVE_TYPE_SECTION_MOVE,"sec":option.row.top.sec,"sub":option.row.top.sub};
			else {
				events.up = {"type":MOVE_TYPE_PAGE_SWITCH_UP,"sec":option.secindex,"sub":(item_id-item_col)%item_perpage};
			}
		} else {
			events.up = {"type":MOVE_TYPE_SUBINDEX_MOVE,"sec":option.secindex,"sub":item_id%item_perpage-item_col};
		}

		//down event
		if(item_id % item_perpage >=  item_perpage - item_col) { // bottom row
			if(option.scrolltype == SCROLLTYPE_HORIZONTAL)
				events.down = "";
			else {
				var current_page_index = Math.floor(item_id/item_perpage);

				if(current_page_index == item_maxpage - 1) {
					events.down = "";
				} else {
					var tar_item_id = item_id + item_col;
					if(tar_item_id >= list_json.length)
						tar_item_id = list_json.length-1;
					events.down = {"type":MOVE_TYPE_PAGE_SWITCH_DOWN,'sec':option.secindex,"sub":tar_item_id%item_perpage};
				}
			}
		} else if (item_id >= item_col*(item_maxrow-1)){
			events.down = "";
		} else {// if last row before should consider the last row not full
			var tar_item = item_id + item_col;
			while(tar_item>=list_json.length) {
				tar_item--;
			}
			events.down = {"type":MOVE_TYPE_SUBINDEX_MOVE,"sec":option.secindex,"sub":tar_item%item_perpage};
		}

		item.events = events;
		item_id++;
		result.sub.push(item);
	});

	return result;
}

//priority highest for checking
var static_focus_enable = true;
function disable_focus() {
	static_focus_enable = false;
}

function enable_focus() {
	static_focus_enable = true;
}

//bug fix for when focus frame cover a tag cause click none reaction
function focus_frame_onclick() {
	global.focus.onClick();
}

//modify the performance
function set_focus_performance(performance) {
	FOCUS_PERFORMANCE_LEVEL = performance;
}

function set_focus_isblocking(isblocking) {
	FOCUS_ISBLOCKING = isblocking;
}

function register_hover_frame (frame) {
	if(FOCUS_RESTORE.hoverframe == undefined) {
		FOCUS_RESTORE.hoverframe = [];
	}

	if($.inArray(frame,FOCUS_RESTORE.hoverframe) == -1 ) {
		FOCUS_RESTORE.hoverframe.push(frame);
	}
}
//for clicking focus sync
function syncwrap_focus(_event) {
	if(_event.data._focus instanceof CFakeFocus) {
		_event.data._focus.onClick();
		//prevent the default event
		_event.preventDefault();
	}
	//if not the CFakeFocus do the default thing
}

function get_target_through_jquery_object(obj) {
	for(var i in global.moveMap) {
		var sec = global.moveMap[i];

		for(var j in sec.mFakeFocus) {
			if(obj[0] == sec.mFakeFocus[j].mJqueryObj[0]) {
				return sec.mFakeFocus[j];
			}
		}
	}
	return false;
}
