/**
 * COMMON 
 * require platform,config file
 */

//list type for gamelist 
var LIST_TYPE_ALL = 0;
var LIST_TYPE_FAVO = 1;
var LIST_TYPE_MOTION = 2;
var LIST_TYPE_LEISURE = 3;
var LIST_TYPE_PUZZLE = 4;
var LIST_TYPE_OTHER = 5;

var LIST_TYPE_ARR = [
	"所有",
	"收藏",
	"体感",
	"休闲",
	"益智",
	"其他"
];

//Platform Game Update Status
var PLATFORM_UPDATE_STATUS_HAS_UPDATE = 0;
var PLATFORM_UPDATE_STATUS_NO_UPDATE = 1;
var PLATFORM_UPDATE_STATUS_UPDATING = 2;
var PLATFORM_UPDATE_STATUS_DOWNLOADED = 3;
var PLATFORM_UPDATE_STATUS_FAILED = 4;

//Game Status
var GAME_STATUS_UNDOWNLOAD = 0;
var GAME_STATUS_DOWNLOADING = 1;
var GAME_STATUS_DOWNLOADED = 2;
var GAME_STATUS_INSTALLED = 3;
var GAME_STATUS_DOWNLOADMD5ERROR = 4;

var GAME_STATUS_NEEDUPDATE = 5;
var GAME_STATUS_UPDATEDOWNLOADING = 6;
var GAME_STATUS_UPDATEDOWNLOADED = 7;
var GAME_STATUS_UPDATED = 8;
var GAME_STATUS_UPDATEDOWNLOADMD5ERROR = 9;
var GAME_STATUS_ABLETOUNINSTALL = 10;

var GAME_STATUS_FUNC_MAP = [];

//Platform CallBack Type
var PLATFORM_CALLBACK_TYPE_KEYEVENT = 0;
var PLATFORM_CALLBACK_TYPE_INSTALLED = 1;
var PLATFORM_CALLBACK_TYPE_UNINSTALLED = 2;
var PLATFORM_CALLBACK_TYPE_UPDATED = 3;
var PLATFORM_CALLBACK_TYPE_DOWNLOADERROR = 4;
var PLATFORM_CALLBACK_TYPE_DOWNLOADED = 5;
var PLATFORM_CALLBACK_TYPE_UPDATEDOWNLOADED = 6;
var PLATFORM_CALLBACK_TYPE_UPDATEERROR = 7;
var PLATFORM_CALLBACK_TYPE_UPDATEINTERNETSTATUS = 8;
var PLATFORM_CALLBACK_TYPE_UPDATEEXTERNALSTORAGESTATUS = 9;
var PLATFORM_CALLBACK_TYPE_UPDATEGAMESTATUS = 10;

var PLATFORM_CALLBACK_FUNC = [];

// for game process downloading
var GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC;

var GAME_DOWNLOADUPDATEPROCESS_INTERVAL = 1000;//ms

//game PLATFORM CALLBACK status change callback
var PLATFORM_CALLBACK_STATUS_CHANGE_FUNC = function(){};

// for every game tips display bind
var TIPS_TYPE_REMOTECHECK = 0;
var TIPS_TYPE_BUYUSBCHECK = 1;
var TIPS_TYPE_SELFDEFINE = 2;

var TIPS_DISPLAY_HANDLE = [];

(function(obj){
	var common = {
		Init:function() {
			// Define Game Console Logical here
			GAME_STATUS_FUNC_MAP = [
				common.DownloadGame,//GAME_STATUS_UNDOWNLOAD
				common.CancelDownloadGame,//GAME_STATUS_DOWNLOADING
				common.InstallGame,//GAME_STATUS_DOWNLOADED
				common.StartGame,//GAME_STATUS_INSTALLED
				common.DownloadGame,//GAME_STATUS_DOWNLOADMD5ERROR
				common.UpdateGame,//GAME_STATUS_NEEDUPDATE
				common.CancelUpdateGame,//GAME_STATUS_UPDATEDOWNLOADING
				common.InstallGame,//GAME_STATUS_UPDATEDOWNLOADED
				common.StartGame,//GAME_STATUS_UPDATED
				common.UpdateGame,//GAME_STATUS_UPDATEDOWNLOADMD5ERROR
				common.UninstallGame//GAME_STATUS_ABLETOUNINSTALL
			];
		},
		/** Index **/
		// Get Ad Banner Json
		GetIndexBannerInfo:function(callback){
			if(!callback || typeof callback != 'function')
				return false;

			var json = platform.getJson(JSON_TYPE_GAMEBANNERINFO);
			return callback(json);
		},

		//Get Index Game List To Fill Up GamePickers
		GetIndexGamePickerList:function(callback){
			vlog('==weblog==','GetIndexGamePickerList Called');
			if(!callback || typeof callback != 'function')
				return false;
			vlog('==weblog==','GetIndexGamePickerList Called');
			var json = platform.getJson(JSON_TYPE_INDEXGAMELIST);
			return callback(json);
		},

		/** GameList **/
		// Get Gamelist To Fill Up GamePickers
		GetGamelistGamePickerList:function(list_type,callback) {
			vlog('==weblog==','GetGamelistGamePickerList Called');
			if(!callback || typeof callback != 'function')
				return false;

			var json = platform.getJson(JSON_TYPE_GAMELIST);
			var result = [];
			if( list_type == LIST_TYPE_ALL ) {
				result = json;
			} else if (list_type == LIST_TYPE_MOTION 
					|| list_type == LIST_TYPE_LEISURE 
					|| list_type == LIST_TYPE_PUZZLE 
					|| list_type == LIST_TYPE_OTHER) {
				$(json).each(function(){
					if(this.type == LIST_TYPE_ARR[list_type]){ // looks like a tricky
						result.push(this);
					}
				});
			} else if( list_type == LIST_TYPE_FAVO ) {
				var favo_json = platform.getJson(JSON_TYPE_FAVORITELIST);

				$(json).each(function(){
					var name =this.appname;
					if( $.inArray(name,favo_json) >= 0 ) {
						result.push(this);
					}
				});
			}
			vlog('==weblog==','GetGamelistGamePickerList Out');
			return callback(result);
		},
		GetSidebarItem:function() {
			var static_sidebar = ["首页","收藏","全部"];

			var json = platform.getJson(JSON_TYPE_GAMELIST);
			for(var i in json) {	
				if($.inArray(json[i].type,static_sidebar) == -1) {
					static_sidebar.push(json[i].type);
				}
			}

			return static_sidebar;
		},

		CurrentGame:'',
		SetCurrentGame:function(game) {
			common.CurrentGame = game;
		},

		/** Game **/
		// Get MayLike List on sidebar
		GetGameLikeList:function(game,callback) {
			if(!callback || typeof callback != 'function')
				return false;

			var json = platform.getJson(JSON_TYPE_GAMELIST);

			var result = [];
			var game_item;
			$(json).each(function(){
				if(this.appname ==  game) {
					game_item = this;
				}
			});
	
			var like_list = [];
			if(game_item) {
			    like_list = game_item.maylike;
			}

			$(json).each(function(){
				var name = this.appname;
				if( $.inArray(name,like_list) >= 0 ) {
					result.push(this);
				}	
			});

			return callback(result);
		},

		// Get Game APK status
		GetGameStatus:function(game,callback,downloadcheck) {
			if(!callback || typeof callback != 'function')
				return false;

			var result = platform.getGameStatus(game);
			vlog('==weblog==','GetGameStatus Result:'+result);


			var d_check = false;
			if(!downloadcheck || downloadcheck == true) {
				d_check = true;
			}

			// Special for process display
			if(result ==  GAME_STATUS_DOWNLOADING && d_check) {
				common.UpdateGameDownloadingProcess(game);
			}

			// Special for process display 2 :)
			if(result == GAME_STATUS_UPDATEDOWNLOADING && d_check) {
				common.UpdateGameUpdateDownloadingProcess(game);
			}

			return callback(game,result);
		},

		// Get Game Description & Scroll Pic
		GetGameInfo:function(game,callback) {
			if(!callback || typeof callback != 'function')
				return false;

			var json = platform.getJson(JSON_TYPE_GAMELIST);

			vlog('==weblog==',"GetGameInfo:"+game);

			var result;

			for(var item in json) {
				if(json[item].appname == game) {
					result = json[item];
					break;
				}
			}

			//update download count
			if(result) {
				var downloadcount = platform.getGameDownloadCount(game);
				result.downloadcount = downloadcount;
			}

			//update category info
			if(result && common.GetText("common","GAMETYPE",result['type'])) {
				result['type'] = common.GetText("common","GAMETYPE",result['type']);
			}

			return callback(result);
		},

		//Get Game Is Favorites
		GetGameIsFavorite:function(game,callback) {
			if(!callback || typeof callback != 'function')
				return false;

			var favo_json = platform.getJson(JSON_TYPE_FAVORITELIST);

			vlog('==weblog==',JSON.stringify(favo_json));
			if($.inArray(game,favo_json)>=0) {
				if(parseInt($$.GetConfig("alwaysfavo"))) {
					vlog('==weblog==',"Always favo");
					return callback(false);
				} else {
					return callback(true);
				}
			 }else
				return callback(false);
		},

		//Set Game Favorite
		SetGameFavorite:function(game,is_f,callback) {
			if(!callback || typeof callback != 'function' )
				return false;

			platform.setFavorite(game,is_f);

			var favo_json = platform.getJson(JSON_TYPE_FAVORITELIST);
			if($.inArray(game,favo_json)>=0) {
				if(parseInt($$.GetConfig('usewebui'))) {
					if(!dialogMgr.getDialogExist("favo")) {
						var fdialog = new CFavoDialog();
						dialogMgr.addDialog("favo",fdialog);
					}
					dialogMgr.setCurrentDialog("favo");
				}
				if(parseInt($$.GetConfig("alwaysfavo"))) {
					vlog('==weblog==',"Always favo");
					return callback(false);
				} else {
					return callback(true);
				}
			} else {
				return callback(false);
			}
		},

		//Start Game
		StartGame:function(game,callback,ischeck) {
			var is_check = (ischeck == undefined) ? true :ischeck;
			if(!is_check || !$$.CheckRemoteIsNeed(game)) {
				$$.StartGameImmediately(game,callback);
			} else {
				TIPS_DISPLAY_HANDLE[TIPS_TYPE_REMOTECHECK].show($$.StartGameImmediately,game,callback);
			}
		},

		//Start Game immediately
		StartGameImmediately:function(game,callback) {
			platform.startGame(game);
			var result = platform.getGameStatus(game);

			if(!callback || typeof callback != 'function' )
				return ;
			else {
				callback(game,result);
			}
		},

		//CheckRemoteIsNeed
		CheckRemoteIsNeed:function(game) {
			var json = platform.getJson(JSON_TYPE_GAMELIST);

			var result;

			for(var item in json) {
				if(json[item].appname == game) {
					result = parseInt(json[item].remote_control);
					break;
				}
			}
			if( result == 0
			// coz defaut show the tips,so comment the codes below 
			//	|| result==undefined 
				|| TIPS_DISPLAY_HANDLE[TIPS_TYPE_REMOTECHECK] == undefined
				|| !TIPS_DISPLAY_HANDLE[TIPS_TYPE_REMOTECHECK] /**cause default return false **/)
			{// no need for show tips
				return false;
			} else {
				return true;
			}
		},

		DownloadLatencyFlag:0,
		DownlaodLatencyBlocking:false,
		DownloadLatencyHandler:null,
		SetLatency:function(flag,time,out_func,callback) {
			if(flag == common.DownloadLatencyFlag && !common.DownloadLatencyHandler) {
				if(!parseInt(time)
				|| !out_func
				|| typeof out_func != 'function'
				) {
					return false;
				}
				if(out_func()) {
					callback();	
					return ;
				}
				var count_down = parseInt(time);
				common.DownlaodLatencyBlocking = true;
				common.DownloadLatencyHandler = setInterval(function(){
					vlog('==weblog==','latency check game status');
					if(out_func() || count_down == 0) {
						callback();
						common.ClearLatency();
						return;
					} 
					count_down--;
				},500);
			}
			return false;
		},

		ClearLatency:function(){
			clearInterval(common.DownloadLatencyHandler);
			common.DownloadLatencyHandler = null
			common.DownlaodLatencyBlocking = false;
		},
		//Download Game
		DownloadGame:function(game,callback,ischeck) {
			var is_check = (ischeck == undefined) ? true :ischeck;
			if(TIPS_DISPLAY_HANDLE[TIPS_TYPE_BUYUSBCHECK] != undefined
				&& TIPS_DISPLAY_HANDLE[TIPS_TYPE_BUYUSBCHECK] !== false
				&& $$.CheckIsNeedBuyUsb(game)) {
				TIPS_DISPLAY_HANDLE[TIPS_TYPE_BUYUSBCHECK].show();
			} else {
				if(!callback || typeof callback != 'function' )
					return ;
				callback(game,GAME_STATUS_DOWNLOADING);
				if (GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC && typeof GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC == 'function')
					GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC(0);

				var status = platform.getGameStatus(game);
				if(status == GAME_STATUS_DOWNLOADING) {
					common.ProecessTimer_handle = setTimeout(common.UpdateGameDownloadingProcess,GAME_DOWNLOADUPDATEPROCESS_INTERVAL,game);
					return ;
				}

				platform.downloadGame(game);

				var result = GAME_STATUS_DOWNLOADING;
				common.SetLatency(common.DownloadLatencyFlag,11,
					function(){
						result = platform.getGameStatus(game);
						if(result != GAME_STATUS_UNDOWNLOAD
							&& result != GAME_STATUS_NEEDUPDATE) {
							return true;
						}
						return false;
					},
					function(){
						if(result == GAME_STATUS_DOWNLOADING) {
							common.ProecessTimer_handle = setTimeout(common.UpdateGameDownloadingProcess,GAME_DOWNLOADUPDATEPROCESS_INTERVAL,game);
						}
						callback(game,result);
					}
				);

				//var result = platform.getGameStatus(game);

				//if(result == GAME_STATUS_DOWNLOADING) {
				//	common.ProecessTimer_handle = setTimeout(common.UpdateGameDownloadingProcess,GAME_DOWNLOADUPDATEPROCESS_INTERVAL,game);
				//}
				
				//if(!callback || typeof callback != 'function' )
				//	return ;
				//else {
				//	callback(game,result);
				//}
			}
		},

		CheckIsNeedBuyUsb:function(game) {
			var json = platform.getJson(JSON_TYPE_GAMELIST);
			var result;

			for(var item in json) {
				if(json[item].appname == game) {
					result = parseInt(json[item].need_buyusb);
					break;
				}
			}
			if(result == 1)
				return true;
			else
				return false;
		},

		UpdateGame:function(game,callback) {
			//current set the button to update
			callback(game,GAME_STATUS_UPDATEDOWNLOADING);
			if (GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC && typeof GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC == 'function')
				GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC(0);

			platform.updateGame(game);

			var result = GAME_STATUS_UPDATEDOWNLOADING;
			common.SetLatency(common.DownloadLatencyFlag,11,
				function(){
					result =platform.getGameStatus(game);

					if(result != GAME_STATUS_UNDOWNLOAD
						&& result != GAME_STATUS_NEEDUPDATE) {
						return true;
					}
					return false;
				},
				function(){
					if(result == GAME_STATUS_UPDATEDOWNLOADING) {
						common.ProecessTimer_handle = setTimeout(common.UpdateGameUpdateDownloadingProcess,GAME_DOWNLOADUPDATEPROCESS_INTERVAL,game);	
					}
					callback(game,result);
				}
			);
/**
			var result = platform.getGameStatus(game);
			if(result == GAME_STATUS_UPDATEDOWNLOADING) {
				common.ProecessTimer_handle = setTimeout(common.UpdateGameUpdateDownloadingProcess,GAME_DOWNLOADUPDATEPROCESS_INTERVAL,game);	
			}

			if(!callback || typeof callback != 'function' )
				return ;
			else {
				callback(game,result);
			}**/
		},

		//Cancel Dowload Game
		CancelDownloadGame:function(game,callback) {
			//if exist latency check it
			if(common.DownlaodLatencyBlocking) {
				return ;
			}
			platform.cancelDownloadGame(game);
			var result = parseInt(platform.getGameStatus(game));

			if(result != GAME_STATUS_DOWNLOADING
				&& result != GAME_STATUS_UPDATEDOWNLOADING) {
				clearInterval(common.ProecessTimer_handle);
			}

			if(!callback || typeof callback != 'function' )
				return ;
			else {
				callback(game,result);
			}
		},

		//Cancel Update Game
		CancelUpdateGame:function(game,callback) {
			//if exist latency check it
			if(common.DownlaodLatencyBlocking) {
				return ;
			}
			platform.cancelUpdateGame(game);
			var result = parseInt(platform.getGameStatus(game));

			if(result != GAME_STATUS_DOWNLOADING
				&& result != GAME_STATUS_UPDATEDOWNLOADING) {
				clearInterval(common.ProecessTimer_handle);
			}

			if(!callback || typeof callback != 'function' )
				return ;
			else {
				callback(game,result);
			}
		},

		//Install Game
		InstallGame:function(game,callback) {
			platform.installGame(game);
			var result = platform.getGameStatus(game);
			
			if(!callback || typeof callback != 'function' )
				return ;
			else {
				callback(game,result);
			}
		},

		//Uninstall Game
		UninstallGame:function(game,callback) {
			platform.uninstallGame(game);
			var result = platform.getGameStatus(game);
			
			if(!callback || typeof callback != 'function' )
				return ;
			else {
				callback(game,result);
			}
		},

		// Call By Page
		GameCall:function(game,game_status,callback,option){
			if(GAME_STATUS_FUNC_MAP[game_status]) {
				GAME_STATUS_FUNC_MAP[game_status](game,callback,option);

				//var status = common.GetGameStatus(game);
			} else {
				//vlog('==weblog==',"");
				return -1;
			}
		},

		//Set Game Downloading Callback
		SetGameDownloadingProcessCallback:function(func) {
			if(!func && typeof func != 'function')
					return false;

			GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC = func;
			return true;
		},

		ProecessTimer_handle:-1,// for download process handler

		UpdateGameDownloadingProcess:function(game){
			vlog('==weblog==',"UpdateGameDownloadingProcess:"+game);
			var process = platform.getDownloadProcess(game);
			vlog('==weblog==',"progress:"+process);
			if (GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC && typeof GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC == 'function')
				GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC(process);

			if(process >= 100) {
				var status = common.GetGameStatus();
				return ;
			}

			common.ProecessTimer_handle 
					= setTimeout(common.UpdateGameDownloadingProcess,GAME_DOWNLOADUPDATEPROCESS_INTERVAL,game);
			vlog('==weblog==',"SetProgressTimeOut:"+game);
		},

		UpdateGameUpdateDownloadingProcess:function(game) {
			vlog('==weblog==',"UpdateGameUpdateDownloadingProcess:"+game);
			var process = platform.getUpdateDownloadProcess(game);
			vlog('==weblog==',"progress:"+process);
			if (GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC && typeof GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC == 'function')
				GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC(process);

			if(process >=100) {
				var status = common.getGameStatus();
				return ;
			}

			common.ProecessTimer_handle 
					= setTimeout(common.UpdateGameUpdateDownloadingProcess,GAME_DOWNLOADUPDATEPROCESS_INTERVAL,game);
			vlog('==weblog==',"SetProgressTimeOut:"+game);

		},

		//Call By Page Bind Platform Call To Page
		SetPlatformCallBack:function(callback_type,func){
			if(!func && typeof func != 'function')
				return false;

			PLATFORM_CALLBACK_FUNC[callback_type] = func;
			return true;
		},

		//Set tips display func
		SetTipsDisplayHandle:function(tips_type,handle,option) {
			if(!handle)
				return false;

			TIPS_DISPLAY_HANDLE[tips_type] = handle;
			return true;
		},

		//Set Status Change Call
		SetPlatformSwitchStatusCallBack:function(func) {
			if(!func && typeof func != 'function')
				return false;

			PLATFORM_CALLBACK_STATUS_CHANGE_FUNC = func;
			return true;
		},


		//Platform Call
		PlatformCall:function(callback_type,game,option) {
			if (!PLATFORM_CALLBACK_FUNC)
				return false;
			if(callback_type == PLATFORM_CALLBACK_TYPE_INSTALLED 
			|| callback_type == PLATFORM_CALLBACK_TYPE_UNINSTALLED
			|| callback_type == PLATFORM_CALLBACK_TYPE_UPDATED 
			|| callback_type == PLATFORM_CALLBACK_TYPE_DOWNLOADERROR
			|| callback_type == PLATFORM_CALLBACK_TYPE_DOWNLOADED
			|| callback_type == PLATFORM_CALLBACK_TYPE_UPDATEDOWNLOADED
			|| callback_type == PLATFORM_CALLBACK_TYPE_UPDATEERROR) {
				vlog('==weblog==',"PlatformCall:"+callback_type);
				if(game != common.GetGamePackageName()) {
					vlog('==weblog==',"current page game not match "+game);
					return false;
				}
				clearInterval(common.ProecessTimer_handle);
				common.ProecessTimer_handle = -1;

				common.ClearLatency();

				var result = platform.getGameStatus(game);

				if( game == common.CurrentGame
					 && (result == GAME_STATUS_DOWNLOADING 
					|| result == GAME_STATUS_UPDATEDOWNLOADING)) {
					if (GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC && typeof GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC == 'function')
						GAME_DOWNLORDINGPROCESS_CALLBACK_FUNC(0);

					var process_func;
					if(result == GAME_STATUS_DOWNLOADING) {
						process_func = common.UpdateGameDownloadingProcess;
					}
					if(result == GAME_STATUS_UPDATEDOWNLOADING) {
						process_func = common.UpdateGameUpdateDownloadingProcess;
					}
					common.ProecessTimer_handle 
							= setTimeout(process_func,GAME_DOWNLOADUPDATEPROCESS_INTERVAL,game);
					
				}

				PLATFORM_CALLBACK_STATUS_CHANGE_FUNC(game,result);
				PLATFORM_CALLBACK_FUNC[callback_type](game,result,option);
			}
		},

		PlatformCall_extern:function(callback_type,para1) {
			if (!PLATFORM_CALLBACK_FUNC)
				return false;

			if(callback_type == PLATFORM_CALLBACK_TYPE_UPDATEINTERNETSTATUS
				|| callback_type == PLATFORM_CALLBACK_TYPE_UPDATEEXTERNALSTORAGESTATUS
				|| callback_type == PLATFORM_CALLBACK_TYPE_UPDATEGAMESTATUS) {
				PLATFORM_CALLBACK_FUNC[callback_type](para1);
			}
		},

		//Update
		
		/** Top **/
		//Get SDCARD status
		GetSDCardStatus:function(callback) {
			if(!callback || typeof callback != 'function' )
				return false;

			var result = platform.getSDCardStatus();
			return callback(result);
		},

		//Get Internet status
		GetInternetConnectionStatus:function(callback) {
			if(!callback || typeof callback != 'function' )
				return false;

			var result = platform.getInternetStatus();
			return callback(result);
		},
		//set internet change callback
		SetInternetStatusChangeCallBack:function(callback) {
			if(!callback || typeof callback != 'function')
				return false;
			PLATFORM_CALLBACK_FUNC[PLATFORM_CALLBACK_TYPE_UPDATEINTERNETSTATUS] = callback;
			return true;
		},

		//set storage change callback
		SetExternalStorageStatusChangeCallBack:function(callback) {
			if(!callback || typeof callback != 'function')
				return false;
			PLATFORM_CALLBACK_FUNC[PLATFORM_CALLBACK_TYPE_UPDATEEXTERNALSTORAGESTATUS] = callback;
			return true;
		},

		//Currency Interface For features
		SetUpdateGameStatusCallBack:function(callback) {
			if(!callback || typeof callback != 'function')
				return false;
			PLATFORM_CALLBACK_FUNC[PLATFORM_CALLBACK_TYPE_UPDATEGAMESTATUS] = callback;
			return true;
		},

		GetPhoneRemoteStatus:function(callback) {
			if(!callback || typeof callback != 'function' )
				return false;

			var result = platform.getPhoneRemoteStatus();
			return callback(result);
		},

		GetRemoteStatus:function(callback) {
			if(!callback || typeof callback != 'function' )
				return false;

			var result = platform.getRemoteStatus();
			return callback(result);
		},

		//Get User Info to be implement
		GetUserInfo:function(callback) {
			if(!callback || typeof callback != 'function' )
				return false;
			/**
			var result = platform.getJson(JSON_TYPE_USERINFO
			**/

			//new method for getting user info
			var device_id = platform.GetDeviceID();
			var userinfo_json = {};
			userinfo_json.id = device_id;
			userinfo_json.username = device_id;
			userinfo_json.money = "0";

			userinfo_json.image = "user3.png";

			return callback(userinfo_json);
		},

		//Get method process override in platform
		GetGamePackageName:function() {
			var result = platform.getExtraString('game');
			//vlog('==weblog==',(typeof result));
			return result;
		},
		SetGamePacakgeName:function(packageName) {
			var result = platform.setExtraValue('game',packageName);
			return result;
		},

		GetGamelistType:function() {
			var result = platform.getExtraInt('gamelist');
			return result;
		},
		SetGamelistType:function(type) {
			var result = platform.setExtraValue('gamelist',type.toString());
			return result;
		},
		ExitGameHall:function() {
			if($$.GetConfig('usewebui')) {
				if( !dialogMgr.getDialogExist("exit") ) {
					var edialog = new CExitDialog();
					dialogMgr.addDialog("exit",edialog);
				}
				dialogMgr.setCurrentDialog("exit");
			} else {
				platform.showExitDialog();
			}
		},
		ExitApp:function() {
			platform.exitApp();
			//coz there is no need to hide it
			//dialogMgr.hideCurrentDialog();
		},
		GetVersion:function(callback) {
			var android_ver = platform.getAndroidGameHallVersion();
			var web_info = platform.getWebGameHallInfo();
			var web_ver = 0;
			if(typeof web_info == 'object' 
			&& typeof web_info.packinfo =='object'
			&& web_info.packinfo.version) {
				web_ver = web_info.packinfo.version;
			}

			var version = android_ver+"_"+web_ver;

			if(typeof callback == 'function') {
				callback(version);
			}
			return version;
		},
		GetSkyType:function(callback) {
			var skytype = platform.getSkytype();

			if(typeof callback == 'function') {
				callback(skytype);
			}

			return skytype;
		},
		GetUDiskType:function(callback){
			var uDiskType = platform.getUdiskType();

			if(typeof callback == 'function') {
				callback(uDiskType);
			}

			return uDiskType;
		},
		GetConfig:function(config,callback) {
			var web_info = platform.getWebGameHallInfo();
			var web_config = {};
			if(typeof web_info == 'object'
			&& typeof web_info.config == 'object' ) {
				web_config = web_info.config;
			}

			if(config) {
				web_config = web_config[config];
			}

			if(typeof callback == 'function') {
				callback(web_config);
			} 
			return web_config;
		},
		CheckGameIfExist:function(game) {
			var info = common.GetGameInfo(game,function(data){
				return data;
			});
			if(!info) {
				return false;
			} else {
				return true;
			}
		},

		//I18N Part
		GetI18NHandler:function(){
			vlog("==weblog==","Get language handler");
			if(!window.i18n.handler) {
				vlog("==weblog==","i18n handler not defined");
				return false;
			}
			return window.i18n.handler;
		},
		AutoFillPage:function() {
			handler = common.GetI18NHandler();
			if(handler) {
				return handler.AutoFill();
			} else {
				return false;
			}
		},
		GetErrorText:function(page,errorindex) {
			handler = common.GetI18NHandler();
			if(handler) {
				return handler.GetResource(page+"/"+"TIPS/"+errorindex);
			} else {
				return false;
			}
		},
		GetText:function(page) {
			if(arguments.length ==0) {
				vlog("==weblog==","Wrong Call GetText");
				return false;
			}	
			var args = Array.prototype.slice.call(arguments);
			var keypath = args.join("/");

			handler = common.GetI18NHandler();

			if(handler) {
				return handler.GetResource(keypath);
			} else {
				return false;
			}
		}
 	}

	common.Init();// Now only for init game status map

	obj.$$ = obj.common = common;
}
)(window);	


var hover_suffix='hover';
var selected_suffix='selected';
var free_suffix='free';
var image_png_suffix='png';
var image_jpg_suffix='jpg';
var suffix_divider='_';

function appendSuffix(src,image_suffix,event_suffix) {
	if(!src)
		return '';
	current_uri = src;
	var strArr1 = [];

	strArr1 = current_uri.split(suffix_divider);
	var filepath_withoutsuffix = '';
	for(var i = 0; i < strArr1.length-1 ; i++) {
		if( 0 === i )
			filepath_withoutsuffix = filepath_withoutsuffix + strArr1[i];
		else
			filepath_withoutsuffix = filepath_withoutsuffix + '_' + strArr1[i];
	}

	return filepath_withoutsuffix + '_' + event_suffix + '.' + image_suffix;
}
