(function(obj){
	function CDialogMgr() {
		this._pool = {};
		this.addDialog = function(index,dialog) {
			this._pool[index] = dialog;
		};

		this.getDialogExist = function(key) {
			return !!this._pool[key];
		}

		this._current = undefined;
		this.setCurrentDialog = function(index) {
			if(!index || !this._pool[index]) {
				vlog("==weblog==","wrong index for dialogmgr");
				return false;
			}
			if(this._pool[index]._needCurrent) {
				this._current = this._pool[index];
				this.showDialog();
			} else {
				this.showDialog(this._pool[index]);
			}
			return true;
		};

		//set the logic of dialog show up
		this.showDialog = function (target) {
			var _target = this._current || target;
			if(global.focus && _target && _target.getType() != 'timeout') {
				global.focus.RemoveFocus();
			}

			if(_target) {
				_target.show();
				this.bindFocusClick(_target);
			}
		}

		this.bindFocusClick = function (target) {
			var _target = target || this._current;
			_target.bindFocusClick();
		}
		this.unbindFocusClick = function () {
			this._current.unbindFocusClick();
		}

		//if return false means not handle the key
		//the true reverse
		this.capture = function(key) {
			if(this._current) {
				return this._current.onKey(key);
			}
			return false;
		};

		this.onclick = function() {
			if(this._current) {
				this._current.onfocusclick();
			}
		}

		this.hideCurrentDialog = function() {
			if(this._current) {
				this._current.vanish();
				this._current = null;
			}

			if(global.focus) {
				var move_out_option = {};
    			move_out_option.remove =  global.focus.getMoveOutOptions();
				global.focus.AppendFocus(move_out_option);
			}

			this._current = undefined;
		}

		this.extraCall = function(index,func,params) {
			if(!this._pool[index]) {
				return ;
			}
			var dialog = this._pool[index];

			dialog[func].apply(dialog,params);
		}
	}
	_manager = new CDialogMgr();
	
	obj.dialogMgr = _manager;
})(window);

function CBaseDialog(keymap,type) {
	this._baseTypeEnum = ['timeout','default']
	this._baseType = 'default';
	//divide the dialog which need the current attribute
	this._needCurrent = true;

	this.getType = function() {
		return this._baseType;
	}

	function inArray(value,arr) {
		for(var i=0;i<arr.length;i++) {
			if(arr[i] == value) {
				return true;
			}
		}
		return false;
	}

	if(type && inArray(type,this._baseTypeEnum)) {
		this._baseType = type;
	}
	
	if(this._baseType == 'timeout') {
		this._needCurrent = false;
	}

	this._movemap = {};
	this._dialogmap = keymap;
	this._focus ;

	this._event = {};
	this.onKey = function(key) {
		vlog('==weblog==',"base capture the key:"+ key);
		return false;
	}

	this.setCallback = function(key,callback) {
		this._event[key] = callback;
	}

	this.init_focus = function() {
		vlog('==weblog==',"base init focus");
	}

	this.initmap = function() {
		init_moveMap(this._movemap,this._dialogmap);

		this.init_focus();
	}

	this.show = function() {
		vlog('==weblog==','base show');
	}

	this.vanish = function() {
		vlog('==weblog==','base vanish');
	}


	this._eventStore = undefined;
	this.bindFocusClick = function() {
		vlog('==weblog==','base bindFocusClick');
	}

	this.unbindFocusClick = function() {
		vlog('==weblog==','base unbindFocusClick');
	}

	this.onfocusclick = function() {
		vlog('==weblog==','base onfocusclick');
	}
}


/** Exit Dialog **/
var exitdialogbutton_hover_frame; 

function CExitDialog() {
	var dialog_tpl = "<div id='bg_box' >"
			+ "<div id='bg_box_font' >是否确认退出？</div>"
			+ "<div id='bg_box_line' ></div>"
			+ "<div id='hallconfirm'><a href='javascript:$$.ExitApp();'  class='confirm_button'></a></div>" 
			+ "<div id='hallcancel'><a href='javascript:dialogMgr.hideCurrentDialog();' class='cancel_button'></a></div>"
			+ "</div>";
	var dialogmap = [
		{"id":0,"tag":"bg_box","sub":[
			{"id":0,"tag":"hallconfirm","tagtype":"id","events":{
				"left":"",
				"right":{"type":MOVE_TYPE_SUBINDEX_MOVE,"sec":0,"sub":1},
				"up":"",
				"down":""
			}},
			{"id":1,"tag":"hallcancel","tagtype":"id","events":{
				"left":{"type":MOVE_TYPE_SUBINDEX_MOVE,"sec":0,"sub":0},
				"right":"",
				"up":"",
				"down":""
			}},
		]}
	];
	
	exitdialogbutton_hover_frame = $("#hover_frame");
	

	this._base = CBaseDialog;
	this._base(dialogmap);

	this.onKey = function(keycode) {
		if(keycode == KEY_NUM1) {
			vlog('==weblog==',"close dialog");
			dialogMgr.hideCurrentDialog();
		}

		if( keycode == KEY_ENTER || keycode == KEY_CENTRE) {
			onFocusClick(keycode,this._movemap,this._focus);
		}
		
		this._focus = onFocusPressMove(keycode,this._movemap,this._focus);

		return true;
	}

	this.show = function() {
		$('body').append(dialog_tpl);
		this.initmap();
	}	
	

	this.init_focus = function() {
		this._focus = this._movemap[0].getFocus(1);
		var move_out_option = {};
		move_out_option.remove =  this._focus.getMoveOutOptions();
		this._focus.AppendFocus(move_out_option);
	};

	this.vanish = function() {
		$('#bg_box').remove();
		$(exitdialogbutton_hover_frame).hide();
	}

	this.bindFocusClick = function() {
		if(exitdialogbutton_hover_frame) {
			if($._data($(exitdialogbutton_hover_frame),"events") 
			&& $._data($(exitdialogbutton_hover_frame),"events")['click']) {
				this._eventStore = $._data($(exitdialogbutton_hover_frame),"events")['click'][0];
			}
			$(exitdialogbutton_hover_frame).unbind('click');
			$(exitdialogbutton_hover_frame).bind('click',function(){
				dialogMgr.onclick();
			})
		}
	}

	this.unbindFocusClick = function() {
		if(exitdialogbutton_hover_frame) {
			$(exitdialogbutton_hover_frame).unbind('click');
			$(exitdialogbutton_hover_frame).bind('click',this._eventStore);
		}
	}

	this.onfocusclick = function() {
		this._focus.onClick();
	}
}

function hallconfirm_focus(JQ_obj,type,buttontype,option,callback) {
	default_focus(exitdialogbutton_hover_frame,JQ_obj,type,buttontype,option,callback);
}

function hallcancel_focus(JQ_obj,type,buttontype,option,callback) {
	default_focus(exitdialogbutton_hover_frame,JQ_obj,type,buttontype,option,callback);
}

