/**
 * ## I18N JS FOR LANGUAGE CHANGE SUPPORT
 * #
 * # Need Jquery
 * # Author:ccsong
 **/

(function(obj){
	var language = getconfig("language");
	
	if(window.i18n_resource == undefined){
		window.i18n_resource = {};
	}
	var handler = {
		GetResource:function(keypath) {
			if(i18n_resource == undefined)
				return false;

			var key_path = keypath.split('/');

			var length = key_path.length;
			var res_copy = $.extend(true,{},i18n_resource);
			for(var i = 0;i<length;i++) {
				var key = key_path[i];
				var upkey = key.toUpperCase();
				var lowkey = key.toLowerCase();
				if(res_copy[lowkey] != undefined) {
					res_copy = res_copy[lowkey];
				} else if(res_copy[upkey] != undefined) {
					res_copy = res_copy[upkey];
				} else {
					return false;
				}
			}

			return res_copy;
		},

		AutoFill:function() {
			var filter = "[id^=res_]";

			if(i18n_resource == undefined)
				return false;
			$("span").filter(filter).each(function(){
				var id = $(this).attr("id");

				var key_path = id.split('_');

				var length = key_path.length;
				var res_copy = $.extend(true,{},i18n_resource);
				for(var i = 1;i<length;i++) {// start from index 1
					var key = key_path[i];
					var upkey = key.toUpperCase();
					var lowkey = key.toLowerCase();
					if(res_copy[lowkey] != undefined) {
						res_copy = res_copy[lowkey];
					} else if(res_copy[upkey] != undefined) {
						res_copy = res_copy[upkey];
					} else {
						break;
					}
				}

				$(this).html(res_copy);
				res_copy = null;//for mem leak opt
			});

			return true;
		}
	}

	var i18n = {};
	i18n.language = language;
	i18n.handler = handler;

	obj.i18n = i18n;
})(window)
