function updateSDCard (json) {
	var sdcard_tag = '#head_sdcard';

	var target = $(sdcard_tag);
	if(target.length == 0) {
		return false;
	}

	var udisktype_ele_cls_arr = [];
	udisktype_ele_cls_arr[UDISK_TYPE_DEFAULT] = {off:"head_sdcard_off",on:"head_sdcard_on"};
	udisktype_ele_cls_arr[UDISK_TYPE_USB] = {off:"head_usb_type_off",on:"head_usb_type_on"};
	udisktype_ele_cls_arr[UDISK_TYPE_SDCARD] = {off:"head_sdcard_type_off",on:"head_sdcard_type_on"};
	udisktype_ele_cls_arr[UDISK_TYPE_BOTH] = {off:"head_both_type_off",on:"head_both_type_on"};

	var udisktype = $$.GetUDiskType();

	udisktype = udisktype_ele_cls_arr[udisktype] ? udisktype : UDISK_TYPE_DEFAULT;

	var off_cls = udisktype_ele_cls_arr[udisktype].off;
	var on_cls = udisktype_ele_cls_arr[udisktype].on;

	if(json == true) {
		target.removeClass(off_cls).addClass(on_cls);
	} else {
		target.removeClass(on_cls).addClass(off_cls);
	}
	return true;
}

function updateInternet (json) {
	var internet_tag = '#head_wifi';

	var target = $(internet_tag);
	if(target.length == 0) {
		return false;
	}

	if(json == true) {
		target.removeClass("head_wifi_off").addClass("head_wifi_on");
	} else {
		target.removeClass("head_wifi_on").addClass("head_wifi_off");
	}
	return true;
}

function updatePhoneRemoteStatus(json) {
	var phone_tag = "#head_phone";

	var target = $(phone_tag);
	if(target.length == 0) {
		return false;
	}

	if(json == true) {
		target.removeClass("head_phone_off").addClass("head_phone_on");
	} else {
		target.removeClass("head_phone_on").addClass("head_phone_off");
	}
	return true;
}

function updateRemoteStatus(json) {
	var remote_tag = '#head_remote';
	var target = $(remote_tag);

	if(target.length == 0) {
		return false;
	}

	if(json == true) {
		target.removeClass("head_remote_off").addClass("head_remote_on");
	} else {
		target.removeClass("head_remote_on").addClass("head_remote_off");
	}
	return true;
}

function init_user() {
	USER.GetDeviceID();
}

function init_top() {
	$$.GetSDCardStatus(updateSDCard);
	$$.GetInternetConnectionStatus(updateInternet);
	$$.GetPhoneRemoteStatus(updatePhoneRemoteStatus);
	$$.GetRemoteStatus(updateRemoteStatus);

	$$.SetInternetStatusChangeCallBack(updateInternet);
	$$.SetExternalStorageStatusChangeCallBack(updateSDCard);

	var zoom = adjust_hall();
	$("body").css({zoom:zoom});
	vlog('==weblog==','page zoom'+zoom);

	$(window).resize(function(){
		var zoom = adjust_hall();
		$("body").css({zoom:zoom});
		vlog('==weblog==','page zoom'+zoom);

		if(global.focus) {
			global.focus.FirstAppendFocus();
		}
	});
}

function init_sidebar() {
	var item_container_tag = "#sidebar_list";
	var item_container = $(item_container_tag);
	var item_container_height = 518;
	if(item_container.length == 0) {
		return false;
	}
	var items = $$.GetSidebarItem();

	var items_size = items.length;

	var item_height = (item_container_height - items_size + 1) / items_size;

	var item_tpl = [
		'<li class="sidebar_list_button" id="{id}" style="height:{height}px">',
			'<a href="javascript:{jumpfunc}">',
				"<div class='sidebar_div'><i></i><span>{itemtext}</span></div>",
			"</a>",
		'<li>'].join("");
	var item_fill_tpl = ["<li class='sidebar_list_fill'></li>"].join("");

	var goto_index_func = "jump2index();";
	var goto_gammelist_func_tpl = "jump2gamelist({flag})";

    var sidebar_arr_idtag = [
        "sidebar_all",//LIST_TYPE_ALL
        "sidebar_favo",//LIST_TYPE_FAVO
        "sidebar_motion",//LIST_TYPE_MOTION
        "sidebar_leisure",//LIST_TYPE_LEISURE
        "sidebar_puzzle",//LIST_TYPE_PUZZLE
        "sidebar_other"//LIST_TYPE_OTHER
    ];

	var items_html_arr = [];
	for(var i in items) {
		var jumpfunc = "";
		var id = "sidebar_index";
		if(items[i] == "首页") {
			jumpfunc = goto_index_func;
		} else {
			var flag = 0;
			for(var j in LIST_TYPE_ARR) {
				if(LIST_TYPE_ARR[j] == items[i]) {
					flag = j;
				}
			}

			id = sidebar_arr_idtag[flag];
			jumpfunc = goto_gammelist_func_tpl.replace(/{flag}/g,flag);	
		}
		var text = $$.GetText('common','GAMETYPE',items[i]);
		var item_context = item_tpl.replace(/{itemtext}/g,text)
							.replace(/{height}/g,item_height)
							.replace(/{jumpfunc}/g,jumpfunc)
							.replace(/{id}/g,id);
		items_html_arr.push(item_context);
	}

	var items_context = items_html_arr.join(item_fill_tpl);

	item_container.html(items_context);
	return items;
}
