var JSON_TYPE_GAMELIST = 0;
var JSON_TYPE_INDEXGAMELIST = 1;
var JSON_TYPE_GAMEBANNERINFO = 2;
var JSON_TYPE_USERINFO = 3;
var JSON_TYPE_FAVORITELIST = 4;
var JSON_TYPE_FILTERLIST = 5;

var UDISK_TYPE_USB = 0;
var UDISK_TYPE_SDCARD = 1;
var UDISK_TYPE_BOTH = 2;
var UDISK_TYPE_DEFAULT = -1;


/** JSON FILE NAME **/
var GAMELIST_FILE = "server_gamelist";
var INDEXGAMELIST_FILE = "server_topten";

(function(obj){
	var CPlatform = function(){
		/** functional **/
		this.output = function(tag,str) {
			window.hallCommonFunc.androidOutput(tag,str);
			return ;
		};

		this.startGame = function(game) {
			window.hallCommonFunc.startPackage(game);
			return ;
		};

		this.installGame = function(game) {
			window.hallCommonFunc.exportInstallPackage(game);
			return ;
		};

		this.updateGame = function(game) {
			vlog('==weblog==',"Call update Game:"+game);
			window.hallCommonFunc.exportUpdateFile(game);
			return ;
		}

		this.downloadGame = function(game) {
			vlog('==weblog==',"Call download Game:"+game);
			window.hallCommonFunc.exportDownloadFile(game);
			return ;
		};

		this.uninstallGame = function(game) {
			window.hallCommonFunc.uninstallPackage(game);
			return ;
		};

		this.cancelDownloadGame = function(game) {
			vlog('==weblog==',"Cancel download game:"+game);
			window.hallCommonFunc.exportCancelDownloadFile(game);
			return ;
		};

		this.cancelUpdateGame = function(game) {
			window.hallCommonFunc.exportCancelUpdateFile(game);
			return ;
		};

		this.getDownloadProcess = function(game) {
			var result = window.hallCommonFunc.exportGetDownloadProcess(game)*100;
			var result_int = parseInt(result);

			return result_int;
		};

		this.getUpdateDownloadProcess = function(game) {
			var result = window.hallCommonFunc.exportGetUpdateProcess(game)*100;
			var result_int = parseInt(result);

			return result_int;
		};

		this.mGameList = undefined;// contain may interest list
		this.mBannerInfo = undefined;
		this.mBannerInfo_default = [{"texture":"banner_big.png","link":"com.trans.pingpang2"},{"texture":"banner_small.png","link":"com.trans.stbxyy2"}];
		this.mIndexGameList = undefined;
		this.mUserInfo = undefined;
		this.mFavoriteList = undefined;
		this.mFilterList = undefined;

		/** Get Set **/
		this.getJson = function(type){
			vlog('==weblog==','Call Platform GetJson:'+type);
			if(type == JSON_TYPE_GAMELIST) {
				vlog('==weblog==',"getJson gamelist");
				if(this.mGameList != undefined) {
					return this.mGameList;
				} else {
					this.mGameList = eval("("+window.hallCommonFunc.exportGetFileContent("server_gamelist")+")");
					vlog('==weblog==',"mGameList:"+JSON.stringify(this.mGameList));
					return this.mGameList;
				}
			} else if( type == JSON_TYPE_GAMEBANNERINFO ) {
				vlog('==weblog==',"getJson ad");
				if(this.mBannerInfo != undefined) {
					return this.mBannerInfo;
				} else {
					this.mBannerInfo = eval("("+window.hallCommonFunc.exportGetFileContent("ad_json_html")+")");
					if(this.mBannerInfo == undefined
						|| this.mBannerInfo.length == undefined
						|| this.mBannerInfo.length == 0) {
						this.mBannerInfo = this.mBannerInfo_default;
					}
					return this.mBannerInfo;
				}
			} else if (type == JSON_TYPE_INDEXGAMELIST ) {
				vlog('==weblog==',"getJson indexgamelist");
				if(this.mIndexGameList != undefined ) {
					vlog('==weblog==',"not undefined");
					return this.mIndexGameList;
				} else {
					this.mIndexGameList = eval("("+window.hallCommonFunc.exportGetFileContent("server_topten")+")");
					vlog('==weblog==',"mIndexGameList:"+JSON.stringify(this.mIndexGameList));
					return this.mIndexGameList;
				}
			} else if (type == JSON_TYPE_USERINFO ) {
				vlog('==weblog==',"getJson userinfo");
				if(this.mUserInfo ) {
					return this.mUserInfo;
				} else {
					this.mUserInfo = eval("("+window.hallCommonFunc.exportGetFileContent(USERINFO_FILE)+")");
					return this.mUserInfo;
				}
			} else if (type == JSON_TYPE_FAVORITELIST ) {
				vlog('==weblog==',"getJson favo");

				var result = window.hallCommonFunc.getFavorites();
					//vlog('==weblog==',(result == ""));
				if (result != "") {
					this.mFavoriteList = eval("("+result+")");
					vlog('==weblog==',(typeof this.mFavoriteList));
				} else {
					this.mFavoriteList = [];
				}
				return this.mFavoriteList;
				
			} else if (type == JSON_TYPE_FILTERLIST ) {
				vlog('==weblog==',"getJson filterlist");
				if(this.mFavoriteList ) {
					return this.mFilterList;
				} else {
					this.mFilterList = eval("("+window.hallCommonFunc.exportGetFileContent(FILTERLIST_FILE)+")");
					return this.mFilterList;
				}
			}
		};

		this.mVersion = undefined;
		this.getAndroidGameHallVersion = function() {
			vlog('==weblog==',"getVersion");
			if(this.mVersion) {
				return this.mVersion;
			} else {
				this.mVersion = ""+window.hallCommonFunc.getVersionName();
				vlog('==weblog==',"getversion result:"+this.mVersion);
				return this.mVersion;
			}
		};

		this.mWebGameHallInfo = undefined;
		this.getWebGameHallInfo = function() {
			vlog('==weblog==',"getWebGameHallInfo");
			if(this.mWebGameHallInfo) {
				return this.mWebGameHallInfo;
			} else {
				var result = ""+window.hallCommonFunc.exportGetFileContent("version");
				vlog('==weblog==',"getwebgamehallinfo result:"+result);
				this.mWebGameHallInfo = eval("("+result+")");
				return this.mWebGameHallInfo;
			}
		};

		//todo: make interface better,make life better
		this.getGameStatus = function(game) {
			vlog('==weblog==','GetGameStatus Call:'+game);
			var result = eval("("+window.hallCommonFunc.exportGetStatus(game)+")");
			vlog('==weblog==','Get game status Result:'+result);

			if(result == GAME_STATUS_INSTALLED) {
				var update_result = eval("("+window.hallCommonFunc.exportGetUpdateStatus(game)+")");
				vlog('==weblog==','Get game update status Result:'+update_result);

				if(update_result == PLATFORM_UPDATE_STATUS_NO_UPDATE) {
					result = result;
				} else if(update_result ==  PLATFORM_UPDATE_STATUS_HAS_UPDATE) {
					result = GAME_STATUS_NEEDUPDATE;
				} else if(update_result ==  PLATFORM_UPDATE_STATUS_UPDATING) {
					result = GAME_STATUS_UPDATEDOWNLOADING;
				} else if(update_result == PLATFORM_UPDATE_STATUS_DOWNLOADED) {
					result = GAME_STATUS_UPDATEDOWNLOADED;
				} else if(update_result == PLATFORM_UPDATE_STATUS_FAILED) {
					result = GAME_STATUS_UPDATEDOWNLOADMD5ERROR;
				}
			}

			return result;
		};

		this.getGameDownloadCount = function(game) {
			var result = eval("("+window.hallCommonFunc.exportGetGameDownloadCount(game)+")");
			return result;
		};

		this.setFavorite = function(game,isfavo) {
			if(isfavo) {
				vlog("==weblog==","Add favorite:"+game);
				return window.hallCommonFunc.addFavorites(game);
			} else {
				vlog("==weblog==","Remove favorite:"+game);
				return window.hallCommonFunc.removeFavorites(game);
			}
		};

		this.getExternalStoreExist = function() {
			return window.hallCommonFunc.externalStorageExist();
		};

		this.getSDCardStatus = function() {
			return window.hallCommonFunc.isSdCardAvailable();
		};

		this.getInternetStatus = function() {
			return window.hallCommonFunc.isNetworkAvailable();
		};

		this.getPhoneRemoteStatus = function() {
			return false;
		};

		this.getRemoteStatus = function() {
			return false;
		};

		/** Store Data In Android **/
		this.setExtraValue = function(key,value) {
			vlog('==weblog==',"setExtraValue Called"+key+"|"+value);
			return window.hallCommonFunc.setExtraData(key,value);
		};

		this.getExtraInt = function(key) {
			vlog('==weblog==',"getExtraValue Called:"+key);
			var result =  eval("("+window.hallCommonFunc.getExtraData(key)+")");
			vlog('==weblog==','getExtraValue result:'+result);
			return result;
		};

		this.getExtraString = function(key) {
			vlog('==weblog==',"getExtraValue Called:"+key);
			var result =  ""+window.hallCommonFunc.getExtraData(key);
			vlog('==weblog==','getExtraValue result:'+result);
			return result;
		};

		this.showExitDialog = function() {
			vlog('==weblog==',"Exit Call");
			window.mainActivity.showExitGameDialog();
		};

		this.exitApp =  function() {
			vlog('==weblog==',"Exit App");
			window.mainActivity.exitApp();
			return ;
		};

		this.getJSFile = function(filename) {
			vlog("==weblog==","getJSFile:"+filename);
			var result =  ""+window.hallCommonFunc.exportGetFileContent(filename);
			vlog("==weblog==",result);
			return result;
		};

		/** User Relate **/
		this.mDeviceID = undefined;
		this.GetDeviceID = function() {
			//var result 
			vlog('==weblog==',"GetDeviceID");
			var result;
			if(this.mDeviceID) {
				result = this.mDeviceID;
			} else if(typeof window.hallCommonFunc.exportGetUserId == 'function') {
				result = ""+window.hallCommonFunc.exportGetUserId();
			} else if(typeof window.hallCommonFunc.exportGetAndroidId == 'function') {
				result = ""+window.hallCommonFunc.exportGetAndroidId();
			} else {
				result = "0000000000000000";
			}
			this.mDeviceID = result;
			vlog('==weblog==',result);
			return result;
		};

		this.mSkyType = undefined;
		this.getSkytype = function() {
			vlog("==weblog==","getSkytype");
			var result;

			if(this.mSkyType) {
				result = this.mSkyType;
			} else if(typeof window.hallCommonFunc.GetSkytype== 'function'){
				result = ""+window.hallCommonFunc.GetSkytype();
			} else {
				result = "";
			}

			this.mSkyType = result;
			vlog("==weblog==",result);
			return result;
		}

		this.mModel = undefined;
		this.getModel = function() {
			vlog("==weblog==","getModel");
			var result;

			if(this.mModel) {
				result = this.mModel;
			} else if(typeof window.hallCommonFunc.GetModel == 'function') {
				result = "" + window.hallCommonFunc.GetModel();
			} else {
				result = "";
			}

			this.mModel = result;
			vlog("==weblog==",result);
			return result;
		}

		this.mMacAddr = undefined;
		this.getMacAddr = function() {
			vlog("==weblog==","getMacAddr");
			var result;

			if(this.mMacAddr) {
				result = this.mMacAddr;
			} else if(typeof window.hallCommonFunc.GetMacAddr == 'function') {
				result = "" + window.hallCommonFunc.GetMacAddr();
			} else {
				result = "";
			}

			this.mMacAddr = result;
			vlog("==weblog==",result);
			return result;
		}

		this.mUdiskType = -1;// 0:Udisk  1:SDCARD   2:both  -1:default
		this.getUdiskType = function() {
			vlog("==weblog==","getUdiskType");

			var result = this.mUdiskType;
			if(typeof window.hallCommonFunc.exportGetUdiskType == 'function') {
				result = parseInt(window.hallCommonFunc.exportGetUdiskType());
			}

			if(result != NaN) {
				this.mUdiskType = result;
			} else {
				result = this.mUdiskType;
			}

			vlog("==weblog==",result);
			return result;
		}
		this.getScreenWidth = function() {
			vlog('==weblog==',"getScreen Width");

			var result = 0;
			if(typeof window.hallCommonFunc.getScreenWidth == 'function') {
				result = parseInt(window.hallCommonFunc.getScreenWidth());
			}

			vlog('==weblog==',result);
			return result;
		}

		this.getScreenHeight = function() {
			vlog('==weblog==','getScreen Height');

			var result = 0;
			if(typeof window.hallCommonFunc.getScreenHeight == 'function') {
				result = parseInt(window.hallCommonFunc.getScreenHeight());
			}

			vlog('==weblog==',result);
			return result;
		}
	}
	obj.platform = new CPlatform();
})(window);

/** Interface  For Android Game Hall **/

// call from Android dispatchKeyEvent
function JSKeyEventCallBack(keycode) {
	function AndroidEvent(keycode) {
		this.which = keycode;
		this.keyCode = keycode;
	}

	var aEvent = new AndroidEvent(keycode);
	vlog('==weblog==',"JSKeyEventCallBack:"+keycode);
	if(grabKey && typeof grabKey == 'function') {
		grabKey(aEvent);
	} else {
		platform.output('==weblog==',"grabKey not defined");
	}
}

function JSGameInstalledCallBack(game) {
	vlog('==weblog==','JSGameInstalledCallBack:'+game+" installed");
	$$.PlatformCall(PLATFORM_CALLBACK_TYPE_INSTALLED,game);
}

function JSGameUninstalledCallBack(game) {
	vlog('==weblog==','JSGameUninstalledCallBack:'+game+' uninstalled');
	$$.PlatformCall(PLATFORM_CALLBACK_TYPE_UNINSTALLED,game);
}

function JSGameUpdatedCallBack(game) {
	vlog('==weblog==','JSGameUpdatedCallBack:'+game+' updated');
	$$.PlatformCall(PLATFORM_CALLBACK_TYPE_UPDATED,game);
}

function JSGameDownloadErrorCallBack(game,status) {
	vlog('==weblog==',"JSGameDownloadErrorCallBack:"+game+" in status:"+status);
	$$.PlatformCall(PLATFORM_CALLBACK_TYPE_DOWNLOADERROR,game,status);
}

function JSGameDownloadFinishedCallBack(game) {
	vlog('==weblog==',"JSGameDownloadFinishedCallBack:"+game);
	$$.PlatformCall(PLATFORM_CALLBACK_TYPE_DOWNLOADED,game);
}

function JSGameUpdateFinishedCallBack(game) {
	vlog('==weblog==',"JSGameUpdateFinishedCallBack:"+game);
	$$.PlatformCall(PLATFORM_CALLBACK_TYPE_UPDATEDOWNLOADED,game)
}

function JSGameUpdateErrorCallBack(game,status) {
	vlog('==weblog==',"JSGameUpdateErrorCallBack:"+game+" in status:"+status);
	$$.PlatformCall(PLATFORM_CALLBACK_TYPE_UPDATEERROR,game,status);
}
function JSInternetStatusChangeCallback(bAvaliable) {
	vlog('==weblog==',"JSInternetStatusChangeCallback"+bAvaliable);
	$$.PlatformCall_extern(PLATFORM_CALLBACK_TYPE_UPDATEINTERNETSTATUS,bAvaliable);
}
function JSExternalStorageChangeCallback(bAvaliable) {
	vlog('==weblog==',"JSExternalStorageChangeCallback"+bAvaliable);
	$$.PlatformCall_extern(PLATFORM_CALLBACK_TYPE_UPDATEEXTERNALSTORAGESTATUS,bAvaliable);

	//$$.PlatformCall_extern(PLATFORM_CALLBACK_TYPE_UPDATEEXTERNALSTORAGESTATUS_GAMEPAGE,bAvaliable);
}
function JSGameStatusChangedCallback(game) {
	vlog('==weblog==',"JSGameStatusChangedCallback:"+game);
	$$.PlatformCall_extern(PLATFORM_CALLBACK_TYPE_UPDATEGAMESTATUS,game);
}

function JSPageLoad(page,option) {
	if(page == 'index') {
		jump2index();
	} else if(page == 'game'){
		jump2game(option);
	} else if(page == 'gamelist') {
		jump2gamelist(option);
	} else if(page == 'user') {
		jump2user();
	} else {
		jump2game(page);
	}
}

//page switch
function jump2game(game) {
	vlog("==weblog==","jump2game:"+game);
	if($$.CheckGameIfExist(game)) {
		$$.SetGamePacakgeName(game);
		window.location.href = global.file_dir + 'game.html';
	}
}

function jump2index() {
	vlog("==weblog==","jump2index");
	window.location.href = global.file_dir +'index.html';
}

function jump2gamelist(index) {
	vlog("==weblog==","jump2gamelist:"+index);
	$$.SetGamelistType(index);
	window.location.href = global.file_dir+'gamelist.html';
}

function jump2user() {
	vlog("==weblog==","jump2user");
	window.location.href = global.file_dir +'user.html';
}
